// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{prelude::*, translate::*};
use std::fmt;

glib::wrapper! {
    #[doc(alias = "DzlPreferences")]
    pub struct Preferences(Interface<ffi::DzlPreferences, ffi::DzlPreferencesInterface>);

    match fn {
        type_ => || ffi::dzl_preferences_get_type(),
    }
}

impl Preferences {
    pub const NONE: Option<&'static Preferences> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Preferences>> Sealed for T {}
}

pub trait PreferencesExt: IsA<Preferences> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_preferences_add_custom")]
    fn add_custom(
        &self,
        page_name: &str,
        group_name: &str,
        widget: &impl IsA<gtk::Widget>,
        keywords: Option<&str>,
        priority: i32,
    ) -> u32 {
        unsafe {
            ffi::dzl_preferences_add_custom(
                self.as_ref().to_glib_none().0,
                page_name.to_glib_none().0,
                group_name.to_glib_none().0,
                widget.as_ref().to_glib_none().0,
                keywords.to_glib_none().0,
                priority,
            )
        }
    }

    #[doc(alias = "dzl_preferences_add_file_chooser")]
    fn add_file_chooser(
        &self,
        page_name: &str,
        group_name: &str,
        schema_id: &str,
        key: &str,
        path: &str,
        title: &str,
        subtitle: &str,
        action: gtk::FileChooserAction,
        keywords: &str,
        priority: i32,
    ) -> u32 {
        unsafe {
            ffi::dzl_preferences_add_file_chooser(
                self.as_ref().to_glib_none().0,
                page_name.to_glib_none().0,
                group_name.to_glib_none().0,
                schema_id.to_glib_none().0,
                key.to_glib_none().0,
                path.to_glib_none().0,
                title.to_glib_none().0,
                subtitle.to_glib_none().0,
                action.into_glib(),
                keywords.to_glib_none().0,
                priority,
            )
        }
    }

    #[doc(alias = "dzl_preferences_add_font_button")]
    fn add_font_button(
        &self,
        page_name: &str,
        group_name: &str,
        schema_id: &str,
        key: &str,
        title: &str,
        keywords: &str,
        priority: i32,
    ) -> u32 {
        unsafe {
            ffi::dzl_preferences_add_font_button(
                self.as_ref().to_glib_none().0,
                page_name.to_glib_none().0,
                group_name.to_glib_none().0,
                schema_id.to_glib_none().0,
                key.to_glib_none().0,
                title.to_glib_none().0,
                keywords.to_glib_none().0,
                priority,
            )
        }
    }

    #[doc(alias = "dzl_preferences_add_group")]
    fn add_group(&self, page_name: &str, group_name: &str, title: &str, priority: i32) {
        unsafe {
            ffi::dzl_preferences_add_group(
                self.as_ref().to_glib_none().0,
                page_name.to_glib_none().0,
                group_name.to_glib_none().0,
                title.to_glib_none().0,
                priority,
            );
        }
    }

    #[doc(alias = "dzl_preferences_add_list_group")]
    fn add_list_group(
        &self,
        page_name: &str,
        group_name: &str,
        title: &str,
        mode: gtk::SelectionMode,
        priority: i32,
    ) {
        unsafe {
            ffi::dzl_preferences_add_list_group(
                self.as_ref().to_glib_none().0,
                page_name.to_glib_none().0,
                group_name.to_glib_none().0,
                title.to_glib_none().0,
                mode.into_glib(),
                priority,
            );
        }
    }

    #[doc(alias = "dzl_preferences_add_page")]
    fn add_page(&self, page_name: &str, title: &str, priority: i32) {
        unsafe {
            ffi::dzl_preferences_add_page(
                self.as_ref().to_glib_none().0,
                page_name.to_glib_none().0,
                title.to_glib_none().0,
                priority,
            );
        }
    }

    #[doc(alias = "dzl_preferences_add_radio")]
    fn add_radio(
        &self,
        page_name: &str,
        group_name: &str,
        schema_id: &str,
        key: &str,
        path: Option<&str>,
        variant_string: Option<&str>,
        title: Option<&str>,
        subtitle: Option<&str>,
        keywords: Option<&str>,
        priority: i32,
    ) -> u32 {
        unsafe {
            ffi::dzl_preferences_add_radio(
                self.as_ref().to_glib_none().0,
                page_name.to_glib_none().0,
                group_name.to_glib_none().0,
                schema_id.to_glib_none().0,
                key.to_glib_none().0,
                path.to_glib_none().0,
                variant_string.to_glib_none().0,
                title.to_glib_none().0,
                subtitle.to_glib_none().0,
                keywords.to_glib_none().0,
                priority,
            )
        }
    }

    #[doc(alias = "dzl_preferences_add_spin_button")]
    fn add_spin_button(
        &self,
        page_name: &str,
        group_name: &str,
        schema_id: &str,
        key: &str,
        path: &str,
        title: &str,
        subtitle: &str,
        keywords: &str,
        priority: i32,
    ) -> u32 {
        unsafe {
            ffi::dzl_preferences_add_spin_button(
                self.as_ref().to_glib_none().0,
                page_name.to_glib_none().0,
                group_name.to_glib_none().0,
                schema_id.to_glib_none().0,
                key.to_glib_none().0,
                path.to_glib_none().0,
                title.to_glib_none().0,
                subtitle.to_glib_none().0,
                keywords.to_glib_none().0,
                priority,
            )
        }
    }

    #[doc(alias = "dzl_preferences_add_switch")]
    fn add_switch(
        &self,
        page_name: &str,
        group_name: &str,
        schema_id: &str,
        key: &str,
        path: Option<&str>,
        variant_string: Option<&str>,
        title: Option<&str>,
        subtitle: Option<&str>,
        keywords: Option<&str>,
        priority: i32,
    ) -> u32 {
        unsafe {
            ffi::dzl_preferences_add_switch(
                self.as_ref().to_glib_none().0,
                page_name.to_glib_none().0,
                group_name.to_glib_none().0,
                schema_id.to_glib_none().0,
                key.to_glib_none().0,
                path.to_glib_none().0,
                variant_string.to_glib_none().0,
                title.to_glib_none().0,
                subtitle.to_glib_none().0,
                keywords.to_glib_none().0,
                priority,
            )
        }
    }

    //#[doc(alias = "dzl_preferences_add_table_row")]
    //fn add_table_row(&self, page_name: &str, group_name: &str, first_widget: &impl IsA<gtk::Widget>, : /*Unknown conversion*//*Unimplemented*/Basic: VarArgs) -> u32 {
    //    unsafe { TODO: call ffi:dzl_preferences_add_table_row() }
    //}

    #[doc(alias = "dzl_preferences_get_widget")]
    #[doc(alias = "get_widget")]
    fn widget(&self, widget_id: u32) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_preferences_get_widget(
                self.as_ref().to_glib_none().0,
                widget_id,
            ))
        }
    }

    #[doc(alias = "dzl_preferences_remove_id")]
    fn remove_id(&self, widget_id: u32) -> bool {
        unsafe {
            from_glib(ffi::dzl_preferences_remove_id(
                self.as_ref().to_glib_none().0,
                widget_id,
            ))
        }
    }

    //#[doc(alias = "dzl_preferences_set_page")]
    //fn set_page(&self, page_name: &str, map: /*Unknown conversion*//*Unimplemented*/HashTable TypeId { ns_id: 0, id: 25 }/TypeId { ns_id: 0, id: 25 }) {
    //    unsafe { TODO: call ffi:dzl_preferences_set_page() }
    //}
}

impl<O: IsA<Preferences>> PreferencesExt for O {}

impl fmt::Display for Preferences {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Preferences")
    }
}
